// zxShutdown.h

#pragma once
#include "Windows.h"

using namespace System;

namespace zxShutdown {

	public enum class ShutdownAction
	{
		Logoff=0x00,
		PowerOff=0x02,
		Reboot=0x08,
		RestartApps=0x40,
	};
	public ref class Shutdown
	{
	public:
		static bool SystemShutdown(ShutdownAction action)
		{
			HANDLE hToken; 
			TOKEN_PRIVILEGES tkp; 

			// Get a token for this process. 
			if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken)) 
				return false; 

			// Get the LUID for the shutdown privilege.  
			LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, &tkp.Privileges[0].Luid); 

			tkp.PrivilegeCount = 1;  // one privilege to set    
			tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED; 

			// Get the shutdown privilege for this process.  
			AdjustTokenPrivileges(hToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES)NULL, 0); 

			if (GetLastError() != ERROR_SUCCESS) 
				return false; 

			// Shut down the system and force all applications to close.  
			if (!ExitWindowsEx((int)action | EWX_FORCE, SHTDN_REASON_MAJOR_OPERATINGSYSTEM |	SHTDN_REASON_MINOR_UPGRADE | SHTDN_REASON_FLAG_PLANNED)) 
				return false; 

			return true;
		}
	};
}
